# -*- encoding=utf8 -*-
__author__ = "liguangyu"

"""
case_tag:cmdc_api,cmdc购买不满足条件买赠商品时验证赠品是否赠送,2262,2262-36,sit,bs
涉及接口:运营后台管理系统登录、活动基本信息获取、活动包含的商品信息和getShoppingCartActivity等接口
"""

from common.common_func import commonFuc
from air_case.cmdc_login.多采商城登录.多采商城登录 import CmdcMaiiLogin
from air_case.cmdc_login.后台管理系统登录.后台管理系统登录 import CmdcDoLogin
import requests
import json
import random

module = "cmdc_commodity_activity"

# 第一步登录后台运营平台获取cmdc_access_token
# 获取登录所需账号密码
username = commonFuc().get_business_data(module, "username1")
password = commonFuc().get_business_data(module, "password1")
# 获取登录后Cmdc_access_token
cmdc_access_token = CmdcDoLogin(username, password).get_token()
headers = commonFuc().get_business_data(module, "json_headers", cmdc_access_token)

# 第二步进行促销活动列表获取
url = commonFuc().get_api_url() + commonFuc().get_business_data(module, "url1")
request_body = commonFuc().get_business_data(module, "payload15")
# 发送请求
result = requests.post(url, json=request_body, headers=headers)
result = json.loads(result.content)

# 获取活动对应的activityBasicId和activityType
activity_basic_id = result["data"]["list"][0]["activityBasicId"]
activity_type = result["data"]["list"][0]["activityType"]

# 第三步获取对应活动包含的商品信息
url = commonFuc().get_api_url() + commonFuc().get_business_data(module, "url3")
request_body = commonFuc().get_business_data(module, "payload3", activity_basic_id, activity_type)
# 发送请求
result = requests.post(url, json=request_body, headers=headers)
result = json.loads(result.content)
print(result)
# 获取活动商品id、companyCode、productCode
company_code = result["data"][0]["companyCode"]
product_code = result["data"][0]["productCode"]
purchase_quantity = random.randint(1, 2)

# 获取登录所需账号密码
username = commonFuc().get_business_data(module, "username")
password = commonFuc().get_business_data(module, "password")
# 获取登录后Cmdc_access_token
cmdc_access_token = CmdcMaiiLogin(username, password).get_token()
headers = commonFuc().get_business_data(module, "json_headers1", cmdc_access_token)

# 第四步验证赠品正确性
url = commonFuc().get_api_url() + commonFuc().get_business_data(module, "url16")
# print(url)
request_body = [
    {"buyerCartId": 0, "purchaseQuantity": purchase_quantity, "productCode": product_code, "companyCode": company_code}]
# print(request_body)

"""
 场景:购买满足条件买赠商品验证赠品是否赠送
 用例名称：购买满足条件买赠商品验证赠品是否赠送
 输出：{"purchaseZeroProductList": []}
"""

# 发送请求
result = requests.post(url, json=request_body, headers=headers)
# 获取接口响应时间
api_time = result.elapsed.total_seconds()
result = json.loads(result.content)
result = {"purchaseZeroProductList": result["data"][0]["purchaseZeroProductList"]}
result["api_time"] = api_time

# 获取预期结果
check_dict = commonFuc().get_business_data(module, "checkDict17")
print(check_dict)
# 断言实际结果中是否包含预期结果的内容
commonFuc().check_result(check_dict, result)
